
;- -------------------------
;-            MCI
;- -------------------------


ProcedureDLL.l Mci_Return(Cde.s)
  Protected *Resultat.l, Retour.l
  *Resultat = AllocateMemory(256)
  Retour = mciSendString_(Cde, *Resultat, 256, 0)
  Retour = Val(PeekS(*Resultat))
  ;GlobalFree_(*Resultat)
  FreeMemory(*Resultat)
  ProcedureReturn Retour
EndProcedure





ProcedureDLL Mci_SetVolume(song$, vol.l)
  mciSendString_("setaudio piste_0"+song$+" right volume to " + Str(vol), #Null, #Null, #Null)
  mciSendString_("setaudio piste_0"+song$+" left  volume to " + Str(vol), #Null, #Null, #Null)
EndProcedure

ProcedureDLL Mci_SetVolume2(song$, lVol.l, rVol.l)
  mciSendString_("setaudio piste_0"+song$+" right volume to " + Str(rVol), #Null, #Null, #Null)
  mciSendString_("setaudio piste_0"+song$+" left  volume to " + Str(lVol), #Null, #Null, #Null)
EndProcedure






; Retourne la longeur de la chanson en 'ms'
;   0 si la chanson n'a pu tre charge
ProcedureDLL Mci_Load(file$, song$)
  Protected time.l
    
  If FileSize(file$) > 0
    If mciSendString_("open "+Chr(34)+ file$ +Chr(34)+" alias piste_0"+song$, #Null, #Null, #Null) = #Null
      mciSendString_("set piste_0"+song$+" time format ms", #Null, #Null, #Null)
      time = Mci_Return("status piste_0"+song$+" length")
      mciSendString_("seek piste_0"+song$+" to start", #Null, #Null, #Null)
      ProcedureReturn time
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure




; Renvoi la position de la chanson en 'ms'
;   -1 sinon
ProcedureDLL Mci_GetPosition(song$)
  If mciSendString_("status piste_0"+song$+" length", #Null, #Null, #Null) <> #Null
    ProcedureReturn -1
  EndIf
  ProcedureReturn Mci_Return("status piste_0"+song$+" length")
EndProcedure




; Lance une chanson depuis 'position' (en ms)
;   position = 0 => On joue la chanson depuis sa position actuelle
;   Renvoi : 1 en cas de succs, 0 sinon
ProcedureDLL Mci_Play(song$, position)
  If position <= 0
    If mciSendString_("play piste_0"+song$, #Null, #Null, #Null) = #Null
      ProcedureReturn #True
    EndIf
  Else
    If mciSendString_("play piste_0"+song$+" from "+Str(position)+" notify", #Null, #Null, #Null) = #Null
      ProcedureReturn #True
    EndIf
  EndIf
EndProcedure




; Renvoi 1 en cas de succs, 0 sinon (chanson non charge)
ProcedureDLL Mci_Resume(song$)
  If mciSendString_("play piste_0"+song$, #Null, #Null, #Null) = #Null
    ProcedureReturn #True
  EndIf
EndProcedure




ProcedureDLL Mci_Pause(song$)
  If mciSendString_("pause piste_0"+song$+" wait", #Null, #Null, #Null) = #Null
    ProcedureReturn #True
  EndIf
EndProcedure




ProcedureDLL Mci_Stop(song$)
  If mciSendString_("close piste_0"+song$, #Null, #Null, #Null) = #Null
    ProcedureReturn #True
  EndIf
EndProcedure



; Renvoi la position de la chanson
ProcedureDLL Mci_SetPosition(song$, time.l)
  Protected length.l

  If mciSendString_("pause piste_0"+song$+" wait", #Null, #Null, #Null) = #Null
    mciSendString_("seek piste_0"+song$+" To End wait", #Null, #Null, #Null)
    length = Mci_Return("status piste_0"+song$+" position wait")
  
    ; Temps indiqu trop important
    If length < time
      If mciSendString_("play piste_0"+song$+" from 1", #Null, #Null, #Null) = #Null
        mciSendString_("pause piste_0"+song$+" wait", #Null, #Null, #Null)
        ProcedureReturn 1
      EndIf
    EndIf
    
    If mciSendString_("play piste_0"+song$+" to " + Str(time), #Null, #Null, #Null) = #Null
      mciSendString_("pause piste_0"+song$+" wait", #Null, #Null, #Null)
      ProcedureReturn time
    EndIf
  EndIf
  ProcedureReturn #Null
EndProcedure


; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 13
; FirstLine = 10
; Folding = --